#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "kohn_bmp.h"

#define THRESHOLD 50

static int check_code(char *code)
{
int c;

  for (c=0; c<12; c++) if (code[c]==-1) return -1;

  c=((code[0]+code[2]+code[4]+code[6]+code[8]+code[10])*3)+
    (code[1]+code[3]+code[5]+code[7]+code[9]);

  //printf("c=%d\n",c);
  c=10-(c%10);
  if (c==10) c=0;

  //printf("%d %d\n", c, code[11]);

  if (c!=code[11]) return -1;

  return 0;
}

static void print_code(char *code)
{
  printf("UPC CODE: %d %d%d%d%d%d %d%d%d%d%d %d\n",
    code[0],
    code[1], code[2], code[3], code[4], code[5],
    code[6], code[7], code[8], code[9], code[10],
    code[11]);
}

#if 0
static int calc_odd(int digit)
{
  //printf("0x%04x\n", digit);
  if (digit==0x3211) return 0;
  if (digit==0x2221) return 1;
  if (digit==0x2122) return 2;
  if (digit==0x1411) return 3;
  if (digit==0x1132) return 4;
  if (digit==0x1231) return 5;
  if (digit==0x1114) return 6;
  if (digit==0x1312) return 7;
  if (digit==0x1213) return 8;
  if (digit==0x3112) return 9;
  return -1;
}
#endif

static int calc_even(int digit)
{
  //printf("0x%04x\n", digit);
  if (digit==0x1123) return 0;
  if (digit==0x1222) return 1;
  if (digit==0x2212) return 2;
  if (digit==0x1141) return 3;
  if (digit==0x2311) return 4;
  if (digit==0x1321) return 5;
  if (digit==0x4111) return 6;
  if (digit==0x2131) return 7;
  if (digit==0x3121) return 8;
  if (digit==0x2113) return 9;
  return -1;
}

static int decode_code(int *barsize, int count, char *code)
{
float sync_size;
int digit_ptr;
int digit,pos;
int c,n;

  for (n=0; n<4; n++)
  {
    if (n<3)
    { sync_size=barsize[n]; }
      else
    { sync_size=(float)(barsize[0]+barsize[1]+barsize[2])/3; }

    digit_ptr=0;
    digit=0;
    pos=0;

    for (c=3; c<count; c++)
    {
      if (c>=3+(6*4) && c<3+(6*4)+5)
      {
        // FIXME - should check size here
        continue;
      }

      int d=barsize[c]/(int)sync_size;
      if ((barsize[c]%(int)sync_size)>((int)sync_size/2)) d++;

      digit|=d<<(digit_ptr*4);
      digit_ptr++;

      if (digit_ptr>=4)
      {
        int c=calc_even(digit);
        if (c<0) break;

        //if (pos>=12) { printf("ZOMG!!\n"); exit(1); }
        code[pos]=c;

        digit_ptr=0;
        digit=0;
        pos++;

        //if (pos==6) skip=5;
        //if (pos>=12) { return 0; }
        //if (pos>=12) { print_barsizes(barsize, barsize_ptr); return 0; }
      }
    }

    if (c==count) return 0;
  }

  return -1;
}

static void remove_noise(unsigned char *buffer, int width)
{
int n;

  for (n=0; n<width-2; n++)
  {
    if (buffer[n]==buffer[n+2] && buffer[n]!=buffer[n+1])
    {
      buffer[n+1]=buffer[n];
    }
  }
}

static void print_barsizes(int *barsize, int count)
{
int c;

  printf(">> ");

  for (c=0; c<count; c++)
  {
    printf(" %d ", barsize[c]);
  }

  printf("\n");
}

static int check_line(unsigned char *in_buffer, int width, int mod, char *code)
{
int state=0;
int count=0;
int n;
int black_sync=99;
int white_sync=99;
int digit=0;
int digit_ptr=0;
unsigned char buffer[width];
//unsigned char buffer[2560];
double sync_size=0;
int barsize[3+(12*4)+5];
int barsize_ptr=0;

//printf("in_buffer=%p\n", in_buffer);
//fflush(stdout);

  for (n=0; n<width; n++)
  {
    buffer[n]=*in_buffer;
    in_buffer=in_buffer+mod;
  }
  remove_noise(buffer, width);

  for (n=0; n<width; n++)
  {
    if (state==0) // Look for white block
    {
      black_sync=0;
      white_sync=0;
      digit_ptr=0;
      count=0;
      digit=0;
      if (buffer[n]==0xff) state++;
    }
      else
    if (state==1) // Look for start of sync
    {
      if (buffer[n]==0x00) { state++; count=1; }
    }
      else
    if (state==2) // Count black sync pixels
    {
//printf("[ %d, %d ]\n", n, row);
      if (buffer[n]==0xff) { state++; black_sync=count; count=0; }
      count++;
    }
      else
    if (state==3) // Count white sync pixels
    {
      if (buffer[n]==0x00) { state++; white_sync=count; count=0; }
      count++;
    }
      else
    if (state==4) // Count black sync pixels
    {
      if (buffer[n]==0xff) { state++; }
      count++;
    }
      else
    if (state==5)
    {
//printf("%d,%d> %d %d %d   %d\n", n, row, black_sync, white_sync, count, state);
//return;
      //if (black_sync!=0 && white_sync!=0 && count!=0)
      if (abs(black_sync-white_sync)<3 && abs(black_sync-count)<3)
      {
        //printf("%d,%d> %d %d %d   %d\n", n, row, black_sync, white_sync, count, state);

        barsize[0]=black_sync;
        barsize[1]=white_sync;
        barsize[2]=count;
        barsize_ptr=3;

        sync_size=(float)(black_sync+white_sync+count)/3;
        count=1;
        state=10;
      }
        else
      {
        state=0;
      }
    }
      else
    if (state==10)
    {
      if (buffer[n]==0x00)
      {
        barsize[barsize_ptr++]=count;
        if (barsize_ptr>=((12*4)+3+5))
        {
          if (decode_code(barsize, barsize_ptr, code)==0) return 0;
          state=0;
          continue;
        }

        count=0;
        state=11;
      }
      count++;
    }
      else
    if (state==11)
    {
      if (buffer[n]==0xff)
      {
        barsize[barsize_ptr++]=count;
        if (barsize_ptr>=((12*4)+3+5))
        {
          if (decode_code(barsize, barsize_ptr, code)==0) return 0;
          state=0;
          continue;
        }

        count=0;
        state=10;
      }
      count++;
    }
  }

  return -1;
}

static void make_mono(unsigned int *color, unsigned char *mono, int len, int threshold)
{
int n,v;

  for (n=0; n<len; n++)
  {
    v=((color[n]&0xff)+((color[n]>>8)&0xff)+((color[n]>>16)&0xff))/3;
    if (v>threshold)
    { mono[n]=0xff; }
      else
    { mono[n]=0x00; }
  }
}

int main(int argc, char *argv[])
{
FILE *in;
struct _pic_info pic_info;
unsigned char *buffer;

  if (argc<2)
  {
    printf("Usage: barcode <input.bmp>\n");
    exit(0);
  }

  in=fopen(argv[1], "rb");
  if (in==NULL)
  {
    printf("Couldn't open input file %s\n", argv[1]);
    exit(1);
  }

#ifdef DEBUG
  struct _bitmap_file bitmap_file;
  struct _bitmap_info bitmap_info;
  read_bitmap_file(in, &bitmap_file);
  read_bitmap_info(in, &bitmap_info);
  display_bmp_info(&bitmap_file, &bitmap_info);
  fseek(in, 0, SEEK_SET);
#endif

  read_bmp(in, &pic_info);
  printf("width=%d\n", pic_info.width);
  printf("height=%d\n", pic_info.height);

  buffer=(unsigned char *)malloc(pic_info.width*pic_info.height);

  make_mono(pic_info.picture, buffer, pic_info.width*pic_info.height,THRESHOLD);

#ifdef DEBUG
  FILE *out=fopen("out.bmp", "wb");
  unsigned char *debug_buff = (unsigned char *)malloc(pic_info.width*pic_info.height*3);
  int n,ptr=0;
  for (n=0; n<pic_info.width*pic_info.height; n++)
  {
    debug_buff[ptr]=buffer[n];
    debug_buff[ptr+1]=buffer[n];
    debug_buff[ptr+2]=buffer[n];
    ptr+=3;
  }

  write_bmp_header(out, pic_info.width, pic_info.height);
  write_bmp_image24(out, debug_buff, pic_info.width, pic_info.height);
  write_bmp_footer(out);
  fclose(out);
  free(debug_buff);
#endif

  char code[12];
  int threshold;

  for (threshold=10; threshold<250; threshold+=20)
  {
printf("threshold %d\n", threshold);
    make_mono(pic_info.picture, buffer, pic_info.width*pic_info.height,threshold);
    for (n=0; n<pic_info.height; n++)
    {
      if (check_line(buffer+(n*pic_info.width), pic_info.width, 1, code)==0 ||
          check_line(buffer+(n*pic_info.width)+(pic_info.width-1), pic_info.width, -1, code)==0)
      {
        if (check_code(code)==0)
        {
          printf("threshold=%d\n", threshold);
          print_code(code);
          threshold=1000;
          break;
        }
      }
    }

    if (threshold<1000)
    for (n=0; n<pic_info.width; n++)
    {
      if (check_line(buffer+n, pic_info.height, pic_info.width, code)==0 ||
          check_line(buffer+(pic_info.height*pic_info.width)-pic_info.width+n, pic_info.height, -pic_info.width, code)==0)
      {
        if (check_code(code)==0)
        {
          printf("threshold=%d\n", threshold);
          print_code(code);
          threshold=1000;
          break;
        }
      }
    }
  }

  free(buffer);
  free(pic_info.picture);

  fclose(in);

  return 0;
}



