/*

kohn_bmp - Copyright 2010 Michael Kohn (mike@mikekohn.net)
This falls under the BSD license.

*/

#ifndef BMP_H
#define BMP_H

/* BMP */

struct _pic_info
{
  int width;
  int height;
  unsigned int *picture;
};

struct _bitmap_file
{
  unsigned char bfType[2];
  unsigned int bfSize;
  unsigned short int reserved1;
  unsigned short int reserved2;
  unsigned int bfOffs;
};

struct _bitmap_info
{
  unsigned int biSize;
  unsigned int biWidth;
  unsigned int biHeight;
  unsigned short int biPlanes;
  unsigned short int biBitCount;
  unsigned int biCompression;
  unsigned int biSizeImage;
  unsigned int biXPelsPerMetre;
  unsigned int biYPelsPerMetre;
  unsigned int biClrUsed;
  unsigned int biClrImportant;
  int colors[256];
};

void write_bmp_header(FILE *out, int width, int height);
void write_bmp_image24(FILE *out, unsigned char *image, int width, int height);
int write_bmp_footer(FILE *out);

void read_bitmap_file(FILE *in, struct _bitmap_file *bitmap_file);
void read_bitmap_info(FILE *in, struct _bitmap_info *bitmap_info);
void raw_uncompressed(FILE *in, unsigned int *picture, struct _bitmap_info *bitmap_info);
void raw_compressed(FILE *in, unsigned int *picture, struct _bitmap_info *bitmap_info);
int read_bmp(FILE *in, struct _pic_info *pic_info);

void display_bmp_info(struct _bitmap_file *bitmap_file, struct _bitmap_info *bitmap_info);

#endif

