#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fileio.h"
#include "kohn_bmp.h"

/*

kohn_bmp - Copyright 2010 Michael Kohn (mike@mikekohn.net)
This falls under the BSD license.

*/

void write_bmp_header(FILE *out, int width, int height)
{
int image_width;

  /* image_width=width*3; */
  image_width=width;
  while ((image_width%4)!=0) image_width++;

/* size: 14 bytes */

  write_chars(out,"BM");
  write_int(out,0);
  write_word(out,0);
  write_word(out,0);
  /* write_int(out,54+1024); */
  write_int(out,54);

/* head1: 14  head2: 40 */

  write_int(out,40);         /* biSize */
  write_int(out,width);
  write_int(out,height);
  write_word(out,1);
  write_word(out,24);
  /* write_word(out,8); */
  write_int(out,0);          /* compression */
  write_int(out,image_width*height);
  write_int(out,0);          /* biXPelsperMetre */
  write_int(out,0);          /* biYPelsperMetre */
  /* write_int(out,0); */
  /* write_int(out,0); */
  write_int(out,0);
  write_int(out,0);

/*
  for (t=0; t<256; t++)
  {
    write_int(out,palette[t]);
  }
*/
}

void write_bmp_image24(FILE *out, unsigned char *image, int width, int height)
{
  int line_ptr=(width*3)*height;
  int ptr;
  int padding=0;
  int x,y;

  if (((width*3)%4)!=0) padding=4-((width*3)%4);

  for (y=0; y<height; y++)
  {
    line_ptr-=width*3;
    ptr=line_ptr;
    for (x=0; x<width; x++)
    {
      putc(image[ptr],out);
      putc(image[ptr+1],out);
      putc(image[ptr+2],out);
      ptr+=3;
    }

    for (x=0; x<padding; x++) putc(0,out);
  }
}

int write_bmp_footer(FILE *out)
{
int marker;

  marker=ftell(out);
  fseek(out,2,SEEK_SET);
  write_int(out,marker);
  fseek(out,marker,SEEK_SET);
  return 0;
}


